using S;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using NetShips.Properties;


namespace NetShips {
    public partial class frmCreate: Form {
        public const int WM_NCLBUTTONDOWN = 0xA1;
        public const int HT_CAPTION = 0x2;

        [DllImportAttribute("user32.dll")]
        public static extern int SendMessage(IntPtr hWnd, int Msg, int wParam, int lParam);
        [DllImportAttribute("user32.dll")]
        public static extern bool ReleaseCapture();



        private Communicator _Com;
        private int port = 10101;
        /// <summary>
        /// Creates new window. Parameter Com is Communicator used for creating connection.
        /// </summary>
        /// <param name="Com"></param>
        public frmCreate(Communicator Com) {
            this.Text = "NetShips v" + Application.ProductVersion;
            _Com = Com;
            InitializeComponent();
            foreach(string s in Settings.Default.AutoIPs)
                txtIP.AutoCompleteCustomSource.Add(s);
            foreach(string s in Settings.Default.AutoNames)
                txtName.AutoCompleteCustomSource.Add(s);
        }

        private void btnCreate_Click(object sender, EventArgs e) {
            Connection_Errs res;
            // shows small window when listening to allow user stop it
            frmListening.ShowMe(_Com, this);

            Application.DoEvents();

            res = _Com.Listen(port);
            frmListening.HideMe();

            HandleConnect(res);
        }

        private void HandleConnect(Connection_Errs res) {
            sblStatus.Text = res.ToString();

            if(res == Connection_Errs.Connected) {
                txtIP.AutoCompleteCustomSource.Add(txtIP.Text);
                txtName.AutoCompleteCustomSource.Add(txtName.Text);
                this.Close();
            }
        }

        private void btnConnect_Click(object sender, EventArgs e) {

            sblStatus.Text = "Connecting to " + txtIP.Text + " on port " + port.ToString();
            Application.DoEvents();

            HandleConnect(_Com.Connect(txtIP.Text, port));

        }

        private void frmCreate_FormClosed(object sender, FormClosedEventArgs e) {
            Program.Names[0] = txtName.Text;
        }

        private void frmCreate_MouseDown(object sender, MouseEventArgs e) {
            if(e.Button == MouseButtons.Left) {
                ReleaseCapture();
                SendMessage(Handle, WM_NCLBUTTONDOWN, HT_CAPTION, 0);
            }
        }

        private void button1_Click(object sender, EventArgs e) {
            this.Close();
        }

        private void lnlMail_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e) {
            string filename = "mailto:ohin-mail@post.cz";
            System.Diagnostics.Process myProcess = new System.Diagnostics.Process();
            myProcess.StartInfo.FileName = filename;
            myProcess.StartInfo.UseShellExecute = true;
            myProcess.StartInfo.RedirectStandardOutput = false;
            myProcess.Start();
        }

        private void frmCreate_FormClosing(object sender, FormClosingEventArgs e) {
            Settings.Default.AutoIPs.Clear();
            foreach(string s in txtIP.AutoCompleteCustomSource)
                Settings.Default.AutoIPs.Add(s);
            Settings.Default.AutoNames.Clear();
            foreach(string s in txtName.AutoCompleteCustomSource)
                Settings.Default.AutoNames.Add(s);

            Settings.Default.Save();
        }
    }
}